/*
 * TCPThread.java
 *
 * Created on 11 de marzo de 2006, 14:35
 */

package Flier_Match.FMCliente.red;
import java.io.*;
import java.net.*;
import com.threed.jpct.*;
import Flier_Match.FMRed.*;
/**
 *
 * @author  Administrador
 * @version 
 */
public class TCPManejo{
    boolean salida;
    private ObjectInputStream entradaOb;
    private ObjectOutputStream salidaOb;
    private Socket cliente;
    
    Respuesta R;
    Object P;
    /** Creates new TCPThread */
    public TCPManejo(String ahost, int apuerto) {
        
        salida=false;
        try {
            cliente=new Socket (ahost, apuerto);
            cliente.setTcpNoDelay(true);
            System.out.println ("Conexion establecida con: "+ahost+" en el puerto: "+apuerto);
        }
        catch (Exception E) {
            System.out.println ("Error creando el socket de construccion");
            E.printStackTrace ();
        }
        
        try {
            entradaOb=new ObjectInputStream (cliente.getInputStream ());
            salidaOb=new ObjectOutputStream (cliente.getOutputStream ());
        } catch (Exception E) {
            System.out.println ("Error creando los flujos para las conexiones");
            E.printStackTrace();
        }
    }
    
    public void enviar (Object ap) {
        P=ap;
        try {
            salidaOb.writeObject (P);
            P=null;
        } catch (Exception E) {
            System.out.println ("Error: "+E.getMessage()+" enviando una peticion al servidor");
            //E.printStackTrace();
        }
    }
    
    public void recibir () {
            R=null;
            try {
                R=(Respuesta) entradaOb.readObject ();
            } catch (Exception E) {
            	System.out.println ("Error: "+E.getMessage()+" leyendo la respuesta por parte del servidor");
                E.printStackTrace();
            }
    }
    
    public Respuesta getRespuesta () {
        return R;
    }
    
    public void salir () {
        salida=true;
        try {
            salidaOb.close ();
            entradaOb.close ();
        } catch (Exception E) {
            System.out.println ("Error cerrando los flujos de datos");
            E.printStackTrace();
        }
    }

}
