/*
 * Lista.java
 *
 * Created on 7 de marzo de 2006, 2:52
 */

package Flier_Match.FMCliente.sistema;
import java.util.ArrayList;

import com.threed.jpct.Object3D;
import com.threed.jpct.SimpleVector;

/**
 *
 * @author  Administrador
 * @version 
 */
public class Lista {
	private ArrayList lista;
    /** Creates new Lista */
    public Lista() {
        lista=new ArrayList ();
    }
    
    public void insertar (Object info) {

    	lista.add(info);
    }
    
    public int getTamao () {
    	/*
        return tamao;*/
    	return (lista.size());
    }
    
    public void separar (float distancia, SimpleVector direccion) {

    	for (int i=0;i<lista.size();i++) {
    		SimpleVector dirtemp=direccion.normalize();
            dirtemp.scalarMul (distancia*i);
            Object3D otemp= (Object3D) lista.get (i);
            otemp.translate (dirtemp);
    	}
        
    }
    
    public void translate (float distancia, SimpleVector direccion) {

    	direccion.normalize ();
        direccion.scalarMul (distancia);
    	for (int i=0;i<lista.size();i++) {
    		Object3D otemp= (Object3D) lista.get (i);
            otemp.translate (direccion);
    	}
    }
    
    public Object3D getObject3DByX (float x, float tolerancia) {

    	for (int i=0;i<lista.size();i++) {
    		Object3D otemp= (Object3D) lista.get(i);
            if (Math.abs (otemp.getTranslation ().x-x) <= tolerancia) return otemp;
    	}
        return null;
    }
    
    public Object getFirstObject () {
    	return (lista.get(0));
    }
    
    public void mover () {
      
    }
}
